# watch-node

> Watch files using the fsevents built into the Mac OS

## Install

```
npm install watch-node
```

## Usage

``` coffeescript
watch = require 'watch-node'

watch './src', (file) ->
  console.log "File changed: #{file}"
```

Here's a `cake` task to watch JS/CSS templates (CoffeeScript, Stylus, etc.) and recompile them.  It works with any file.

``` coffeescript
fs      = require 'fs'
path    = 
watch   = require 'watch-node'
Shift   = require 'shift'

task 'watch', 'Compile asset templates', ->
  watch './src', (file, curr, prev) ->
    fs.readFile file, 'utf-8', (error, input) ->
      throw error if error
    
      inputExtension  = path.extname(file)
      outputExtension = switch inputExtension
        when ".coffee", ".ejs" then ".js"
        when ".styl", ".less", ".sass" then ".css"
      engine          = Shift.engine extension
      outputPath      = file.replace(/^\.\/src/, "./lib").replace(new RegExp("#{inputExtension}$"), outputExtension)
    
      engine.render input, (error, output) ->
        fs.writeFile outputPath, output
```