(function() {
  var FSEvents, fs, _path;
  fs = require('fs');
  FSEvents = require("fsevents");
  _path = require('path');
  module.exports = function(base, callback) {
    var cache, paths, self, source, stat, _i, _len;
    global.fse = new FSEvents(base);
    paths = require('findit').sync(base);
    cache = {};
    self = this;
    for (_i = 0, _len = paths.length; _i < _len; _i++) {
      source = paths[_i];
      stat = fs.statSync(source);
      if (!stat.isDirectory()) {
        cache[_path.join(process.cwd(), source)] = stat;
      }
    }
    return fse.on("change", function(path, flags, evtid, asdf) {
      var curr, entries, entry, file, prev, relative, timestamp, _j, _len2;
      entries = fs.readdirSync(path);
      for (_j = 0, _len2 = entries.length; _j < _len2; _j++) {
        entry = entries[_j];
        if (!(entry === '.' || entry === '..')) {
          file = _path.join(path, entry);
          curr = fs.statSync(file);
          if (!curr.isDirectory()) {
            prev = cache[file];
            if (!(prev && curr.size === prev.size && curr.mtime.getTime() === prev.mtime.getTime())) {
              cache[file] = curr;
              timestamp = (new Date).toLocaleTimeString();
              relative = file.replace(process.cwd().toString() + '/', '');
              console.log("" + timestamp + " - changed " + relative);
              try {
                callback.call(self, file, prev, curr);
              } catch (error) {
                console.log(error.message);
              }
            }
          }
        }
      }
      if (fs.statSync("stop")) {
        console.log("Stop");
        fs.unlinkSync("stop");
        return fse.stop();
      }
    });
  };
}).call(this);
