fs              = require 'fs'
FSEvents        = require("fsevents")
_path           = require 'path'

module.exports  = (base, callback) ->
  global.fse    = new FSEvents(base)
  paths         = require('findit').sync(base) # fs.readdirSync(base)
  cache         = {}
  self          = @
  
  for source in paths
    stat = fs.statSync(source)
    
    unless stat.isDirectory()
      cache[_path.join(process.cwd(), source)] = stat
  
  fse.on "change", (path, flags, evtid, asdf) ->
    entries = fs.readdirSync(path)
    for entry in entries
      unless entry == '.' || entry == '..'
        file = _path.join(path, entry)
        curr = fs.statSync(file)
        unless curr.isDirectory()
          prev = cache[file]
          unless prev && curr.size == prev.size && curr.mtime.getTime() == prev.mtime.getTime()
            cache[file] = curr
            timestamp   = (new Date).toLocaleTimeString()
            relative    = file.replace(process.cwd().toString() + '/', '')
            console.log "#{timestamp} - changed #{relative}"
            
            try
              callback.call(self, file, prev, curr)
            catch error
              console.log error.message
          
    if fs.statSync("stop")
      console.log "Stop"
      fs.unlinkSync "stop"
      fse.stop()